' 2006/02/22 GG - added iQuaternionSpline() function introduced in v4.1.0

Type _3IMATH

	Method VectorBodyToWorldTransform(transformedCoords:D3DXVECTOR3,coords:D3DXVECTOR3,bdy:BODY,mode:Int)
		_iVectorBodyToWorldTransform(transformedCoords.param(),coords.param(),bdy.objptr,mode)
	EndMethod
	
	Method VectorBodyToWorldRotate(transformedCoords:D3DXVECTOR3,coords:D3DXVECTOR3,bdy:BODY,mode:Int)
		_iVectorBodyToWorldRotate(transformedCoords.param(),coords.param(),bdy.objptr,mode)
	EndMethod
	
	Method VectorMeshToWorldTransform(transformedCoords:D3DXVECTOR3,coords:D3DXVECTOR3,msh:MESH)
		_iVectorMeshToWorldTransform(transformedCoords.param(),coords.param(),msh.objptr)
	EndMethod
	
	Method VectorMeshToWorldRotate(transformedCoords:D3DXVECTOR3,coords:D3DXVECTOR3,msh:MESH)
		_iVectorMeshToWorldRotate(transformedCoords.param(),coords.param(),msh.objptr)
	EndMethod
	
	Method VectorSkinMeshToWorldTransform(transformedCoords:D3DXVECTOR3,coords:D3DXVECTOR3,sknmsh:SKINMESH)
		_iVectorSkinMeshToWorldTransform(transformedCoords.param(),coords.param(),sknmsh.objptr)
	EndMethod
	
	Method VectorSkinMeshToWorldRotate(transformedCoords:D3DXVECTOR3,coords:D3DXVECTOR3,sknmsh:SKINMESH)
		_iVectorSkinMeshToWorldRotate(transformedCoords.param(),coords.param(),sknmsh.objptr)
	EndMethod
	
	Method VectorWorldToBodyTransform(transformedCoords:D3DXVECTOR3,coords:D3DXVECTOR3,bdy:BODY)
		_iVectorWorldToBodyTransform(transformedCoords.param(),coords.param(),bdy.objptr)
	EndMethod
	
	Method VectorWorldToBodyRotate(transformedCoords:D3DXVECTOR3,coords:D3DXVECTOR3,bdy:BODY)
		_iVectorWorldToBodyRotate(transformedCoords.param(),coords.param(),bdy.objptr)
	EndMethod
	
	Method VectorWorldToMeshTransform(transformedCoords:D3DXVECTOR3,coords:D3DXVECTOR3,msh:MESH)
		_iVectorWorldToMeshTransform(transformedCoords.param(),coords.param(),msh.objptr)
	EndMethod
	
	Method VectorWorldToMeshRotate(transformedCoords:D3DXVECTOR3,coords:D3DXVECTOR3,msh:MESH)
		_iVectorWorldToMeshRotate(transformedCoords.param(),coords.param(),msh.objptr)
	EndMethod
	
	Method VectorWorldToSkinMeshTransform(transformedCoords:D3DXVECTOR3,coords:D3DXVECTOR3,sknmsh:SKINMESH)
		_iVectorWorldToSkinMeshTransform(transformedCoords.param(),coords.param(),sknmsh.objptr)
	EndMethod
	
	Method VectorWorldToSkinMeshRotate(transformedCoords:D3DXVECTOR3,coords:D3DXVECTOR3,sknmsh:SKINMESH)
		_iVectorWorldToSkinMeshRotate(transformedCoords.param(),coords.param(),sknmsh.objptr)
	EndMethod
	
	Method VectorModelToBodyTransform(transformedCoords:D3DXVECTOR3,coords:D3DXVECTOR3,bdy:BODY)
		_iVectorModelToBodyTransform(transformedCoords.param(),coords.param(),bdy.objptr)
	EndMethod
	
	Method VectorBodyToModelTransform(transformedCoords:D3DXVECTOR3,coords:D3DXVECTOR3,bdy:BODY)
		_iVectorBodyToModelTransform(transformedCoords.param(),coords.param(),bdy.objptr)
	EndMethod
	
	Method VectorRotate(transformedCoords:D3DXVECTOR3,coords:D3DXVECTOR3,rotation:D3DXQUATERNION)
		_iVectorRotate(transformedCoords.param(),coords.param(),rotation.param())
	EndMethod
	
	Method VectorEulerRotate(transformedCoords:D3DXVECTOR3,coords:D3DXVECTOR3,firstRotation:Float,secondRotation:Float,thirdRotation:Float,rotationOrder:String)
		_iVectorEulerRotate(transformedCoords.param(),coords.param(),firstRotation,secondRotation,thirdRotation,rotationOrder)
	EndMethod
	
	Method VectorsAngleToQuaternion(rotation:D3DXQUATERNION,vector1:D3DXVECTOR3,vector2:D3DXVECTOR3,transformationFactor:Float)
		_iVectorsAngleToQuaternion(rotation.param(),vector1.param(),vector2.param(),transformationFactor)
	EndMethod
	
	Method VectorsAngle:Float(vector1:D3DXVECTOR3,vector2:D3DXVECTOR3)
		Return _iVectorsAngle(vector1.param(),vector2.param())
	EndMethod
	
	Method VectorLength:Float(vector:D3DXVECTOR3)
		Return _iVectorLength(vector.param())
	EndMethod
	
	Method VectorLengthSq:Float(vector:D3DXVECTOR3)
		Return _iVectorLengthSq(vector.param())
	EndMethod
	
	Method VectorLengthSet(transformed:D3DXVECTOR3,source:D3DXVECTOR3,length:Float)
		_iVectorLengthSet(transformed.param(),source.param(),length)
	EndMethod
	
	Method VectorDot:Float(vector1:D3DXVECTOR3,vector2:D3DXVECTOR3)
		Return _iVectorDot(vector1.param(),vector2.param())
	EndMethod
	
	Method VectorCross(result:D3DXVECTOR3,source1:D3DXVECTOR3,source2:D3DXVECTOR3)
		_iVectorCross(result.param(),source1.param(),source2.param())
	EndMethod
	
	Method QuaternionFromAxisAngle(result:D3DXQUATERNION,orientation:D3DXVECTOR3,orientationAngle:Float)
		_iQuaternionFromAxisAngle(result.param(),orientation.param(),orientationAngle)
	EndMethod
	
	Method QuaternionToAxisAngle(source:D3DXQUATERNION,orientation:D3DXVECTOR3,orientationAngle:Float Var)
		_iQuaternionToAxisAngle(source.param(),orientation.param(),Varptr(orientationAngle))
	EndMethod
	
	Method QuaternionFromEulerAngles(result:D3DXQUATERNION,firstRotation:Float,secondRotation:Float,thirdRotation:Float,rotationOrder:String)
		_iQuaternionFromEulerAngles(result.param(),firstRotation,secondRotation,thirdRotation,rotationOrder)
	EndMethod
	
	Method QuaternionToEulerAngles(source:D3DXQUATERNION,orientationAngleX:Float Var,orientationAngleY:Float Var,orientationAngleZ:Float Var)
		_iQuaternionToEulerAngles(source.param(),Varptr(orientationAngleX),Varptr(orientationAngleY),Varptr(orientationAngleZ))
	EndMethod
	
	' new in v4.1.0
	Method QuaternionInterpolate(result:D3DXQUATERNION,source1:D3DXQUATERNION,source2:D3DXQUATERNION,orientationFactor:Float)
		_iQuaternionInterpolate(result.param(),source1.param(),source2.param(),orientationFactor)
	EndMethod

	Method QuaternionSpline(result:D3DXQUATERNION,preceeding:D3DXQUATERNION,q1_orientation:D3DXQUATERNION,q2_orientation:D3DXQUATERNION,following_orientation:D3DXQUATERNION,intermmediate_orientation:Float)
		_iQuaternionSpline(result.param(),preceeding.param(),q1_orientation.param(),q2_orientation.param(),following_orientation:D3DXQUATERNION,intermmediate_orientation)
	EndMethod

	Method QuaternionLookAt(result:D3DXQUATERNION,direction:D3DXVECTOR3,upDirection:D3DXVECTOR3)
		Local pUpDirection:Byte Ptr=Null
		If upDirection<>Null Then pUpDirection=upDirection.param()
		_iQuaternionLookAt(result.param(),direction.param(),pUpDirection)
	EndMethod
	
	Method QuaternionMultiply(result:D3DXQUATERNION,source1:D3DXQUATERNION,source2:D3DXQUATERNION)
		_iQuaternionMultiply(result.param(),source1.param(),source2.param())
	EndMethod
	
	Method PlaneFromPointNormal(result:D3DXPLANE,reference3DPoint:D3DXVECTOR3,referenceDirection:D3DXVECTOR3)
		_iPlaneFromPointNormal(result.param(),reference3DPoint.param(),referenceDirection.param())
	EndMethod
	
	Method PlaneFromPoints(result:D3DXPLANE,first3DPoint:D3DXVECTOR3,second3DPoint:D3DXVECTOR3,third3DPoint:D3DXVECTOR3)
		_iPlaneFromPoints(result.param(),first3DPoint.param(),second3DPoint.param(),third3DPoint.param())
	EndMethod
	
	Method PlaneLineIntersection:Int(result:D3DXVECTOR3,pln:D3DXPLANE,firstSegmentPoint:D3DXVECTOR3,secondSegmentPoint:D3DXVECTOR3)
		Return _iPlaneLineIntersection(result.param(),pln.param(),firstSegmentPoint.param(),secondSegmentPoint.param())
	EndMethod
	
	Method FloatTendTo(toAdjust:Float Var,targetValue:Float,approxTimeTaken:Float)
		_iFloatTendTo(Varptr(toAdjust),targetValue,approxTimeTaken)
	EndMethod
	
	Method FloatClamp(toClamp:Float Var,minInclusive:Float,maxInclusive:Float)
		_iFloatClamp(Varptr(toClamp),minInclusive,maxInclusive)
	EndMethod
	
	Method IntClamp(toClamp:Int Var,minInclusive:Int,maxInclusive:Int)
		_iIntClamp(Varptr(toClamp),minInclusive,maxInclusive)
	EndMethod
	
	Method FloatAdd(toIncrease:Float Var,increment:Float)
		_iFloatAdd(Varptr(toIncrease),increment)
	EndMethod
	
	Method FloatAbs:Float(value:Float)
		Return _iFloatAbs(value)
	EndMethod
	
	Method FloatRand:Float(lowerValue:Float,upperValue:Float)
		Return _iFloatRand(lowerValue,upperValue)
	EndMethod
	
	Method IntRand:Int(lowerValue:Int,upperValue:Int)
		Return _iIntRand(lowerValue,upperValue)
	EndMethod
	
	Method SignRand:Float()
		Return _iSignRand()
	EndMethod
	
	Method FloatInterpolate:Float(_input:Float,sourceMin:Float,sourceMax:Float,destMin:Float,destMax:Float,bClamp:Int)
		Return _iFloatInterpolate(_input,sourceMin,sourceMax,destMin,destMax,bClamp)
	EndMethod

EndType

Function iVectorBodyToWorldTransform(transformedCoords:D3DXVECTOR3,coords:D3DXVECTOR3,bdy:BODY,mode:Int)
	_g_3IEngine.math.VectorBodyToWorldTransform(transformedCoords,coords,bdy,mode)
EndFunction

Function iVectorBodyToWorldRotate(transformedCoords:D3DXVECTOR3,coords:D3DXVECTOR3,bdy:BODY,mode:Int)
	_g_3IEngine.math.VectorBodyToWorldRotate(transformedCoords,coords,bdy,mode)
EndFunction

Function iVectorMeshToWorldTransform(transformedCoords:D3DXVECTOR3,coords:D3DXVECTOR3,msh:MESH)
	_g_3IEngine.math.VectorMeshToWorldTransform(transformedCoords,coords,msh)
EndFunction

Function iVectorMeshToWorldRotate(transformedCoords:D3DXVECTOR3,coords:D3DXVECTOR3,msh:MESH)
	_g_3IEngine.math.VectorMeshToWorldRotate(transformedCoords,coords,msh)
EndFunction

Function iVectorSkinMeshToWorldTransform(transformedCoords:D3DXVECTOR3,coords:D3DXVECTOR3,sknmsh:SKINMESH)
	_g_3IEngine.math.VectorSkinMeshToWorldTransform(transformedCoords,coords,sknmsh)
EndFunction

Function iVectorSkinMeshToWorldRotate(transformedCoords:D3DXVECTOR3,coords:D3DXVECTOR3,sknmsh:SKINMESH)
	_g_3IEngine.math.VectorSkinMeshToWorldRotate(transformedCoords,coords,sknmsh)
EndFunction

Function iVectorWorldToBodyTransform(transformedCoords:D3DXVECTOR3,coords:D3DXVECTOR3,bdy:BODY)
	_g_3IEngine.math.VectorWorldToBodyTransform(transformedCoords,coords,bdy)
EndFunction

Function iVectorWorldToBodyRotate(transformedCoords:D3DXVECTOR3,coords:D3DXVECTOR3,bdy:BODY)
	_g_3IEngine.math.VectorWorldToBodyRotate(transformedCoords,coords,bdy)
EndFunction

Function iVectorWorldToMeshTransform(transformedCoords:D3DXVECTOR3,coords:D3DXVECTOR3,msh:MESH)
	_g_3IEngine.math.VectorWorldToMeshTransform(transformedCoords,coords,msh)
EndFunction

Function iVectorWorldToMeshRotate(transformedCoords:D3DXVECTOR3,coords:D3DXVECTOR3,msh:MESH)
	_g_3IEngine.math.VectorWorldToMeshRotate(transformedCoords,coords,msh)
EndFunction

Function iVectorWorldToSkinMeshTransform(transformedCoords:D3DXVECTOR3,coords:D3DXVECTOR3,sknmsh:SKINMESH)
	_g_3IEngine.math.VectorWorldToSkinMeshTransform(transformedCoords,coords,sknmsh)
EndFunction

Function iVectorWorldToSkinMeshRotate(transformedCoords:D3DXVECTOR3,coords:D3DXVECTOR3,sknmsh:SKINMESH)
	_g_3IEngine.math.VectorWorldToSkinMeshRotate(transformedCoords,coords,sknmsh)
EndFunction

Function iVectorModelToBodyTransform(transformedCoords:D3DXVECTOR3,coords:D3DXVECTOR3,bdy:BODY)
	_g_3IEngine.math.VectorModelToBodyTransform(transformedCoords,coords,bdy)
EndFunction

Function iVectorBodyToModelTransform(transformedCoords:D3DXVECTOR3,coords:D3DXVECTOR3,bdy:BODY)
	_g_3IEngine.math.VectorBodyToModelTransform(transformedCoords,coords,bdy)
EndFunction

Function iVectorRotate(transformedCoords:D3DXVECTOR3,coords:D3DXVECTOR3,rotation:D3DXQUATERNION)
	_g_3IEngine.math.VectorRotate(transformedCoords,coords,rotation)
EndFunction

Function iVectorEulerRotate(transformedCoords:D3DXVECTOR3,coords:D3DXVECTOR3,firstRotation:Float,secondRotation:Float,thirdRotation:Float,rotationOrder:String)
	_g_3IEngine.math.VectorEulerRotate(transformedCoords,coords,firstRotation,secondRotation,thirdRotation,rotationOrder)
EndFunction

Function iVectorsAngleToQuaternion(rotation:D3DXQUATERNION,vector1:D3DXVECTOR3,vector2:D3DXVECTOR3,transformationFactor:Float)
	_g_3IEngine.math.VectorsAngleToQuaternion(rotation,vector1,vector2,transformationFactor)
EndFunction

Function iVectorsAngle:Float(vector1:D3DXVECTOR3,vector2:D3DXVECTOR3)
	Return _g_3IEngine.math.VectorsAngle(vector1,vector2)
EndFunction

Function iVectorLength:Float(vector:D3DXVECTOR3)
	Return _g_3IEngine.math.VectorLength(vector)
EndFunction

Function iVectorLengthSq:Float(vector:D3DXVECTOR3)
	Return _g_3IEngine.math.VectorLengthSq(vector)
EndFunction

Function iVectorLengthSet(transformed:D3DXVECTOR3,source:D3DXVECTOR3,length:Float)
	_g_3IEngine.math.VectorLengthSet(transformed,source,length)
EndFunction

Function iVectorDot:Float(vector1:D3DXVECTOR3,vector2:D3DXVECTOR3)
	Return _g_3IEngine.math.VectorDot(vector1,vector2)
EndFunction

Function iVectorCross(result:D3DXVECTOR3,source1:D3DXVECTOR3,source2:D3DXVECTOR3)
	_g_3IEngine.math.VectorCross(result,source1,source2)
EndFunction

Function iQuaternionFromAxisAngle(result:D3DXQUATERNION,orientation:D3DXVECTOR3,orientationAngle:Float)
	_g_3IEngine.math.QuaternionFromAxisAngle(result,orientation,orientationAngle)
EndFunction

Function iQuaternionToAxisAngle(source:D3DXQUATERNION,orientation:D3DXVECTOR3,orientationAngle:Float Var)
	_g_3IEngine.math.QuaternionToAxisAngle(source,orientation,orientationAngle)
EndFunction

Function iQuaternionFromEulerAngles(result:D3DXQUATERNION,firstRotation:Float,secondRotation:Float,thirdRotation:Float,rotationOrder:String)
	_g_3IEngine.math.QuaternionFromEulerAngles(result,firstRotation,secondRotation,thirdRotation,rotationOrder)
EndFunction

Function iQuaternionToEulerAngles(source:D3DXQUATERNION,orientationAngleX:Float Var,orientationAngleY:Float Var,orientationAngleZ:Float Var)
	_g_3IEngine.math.QuaternionToEulerAngles(source,orientationAngleX,orientationAngleY,orientationAngleZ)
EndFunction

Function iQuaternionInterpolate(result:D3DXQUATERNION,source1:D3DXQUATERNION,source2:D3DXQUATERNION,orientationFactor:Float)
	_g_3IEngine.math.QuaternionInterpolate(result,source1,source2,orientationFactor)
EndFunction

Function iQuaternionSpline(result:D3DXQUATERNION,preceeding:D3DXQUATERNION,q1_orientation:D3DXQUATERNION,q2_orientation:D3DXQUATERNION,following_orientation:D3DXQUATERNION,intermmediate_orientation:Float)
	_g_3IEngine.math.QuaternionSpline(result,preceeding,q1_orientation,q2_orientation,following_orientation,intermmediate_orientation)
EndFunction

Function iQuaternionLookAt(result:D3DXQUATERNION,direction:D3DXVECTOR3,upDirection:D3DXVECTOR3)
	_g_3IEngine.math.QuaternionLookAt(result,direction,upDirection)
EndFunction

Function iQuaternionMultiply(result:D3DXQUATERNION,source1:D3DXQUATERNION,source2:D3DXQUATERNION)
	_g_3IEngine.math.QuaternionMultiply(result,source1,source2)
EndFunction

Function iPlaneFromPointNormal(result:D3DXPLANE,reference3DPoint:D3DXVECTOR3,referenceDirection:D3DXVECTOR3)
	_g_3IEngine.math.PlaneFromPointNormal(result,reference3DPoint,referenceDirection)
EndFunction

Function iPlaneFromPoints(result:D3DXPLANE,first3DPoint:D3DXVECTOR3,second3DPoint:D3DXVECTOR3,third3DPoint:D3DXVECTOR3)
	_g_3IEngine.math.PlaneFromPoints(result,first3DPoint,second3DPoint,third3DPoint)
EndFunction

Function iPlaneLineIntersection:Int(result:D3DXVECTOR3,pln:D3DXPLANE,firstSegmentPoint:D3DXVECTOR3,secondSegmentPoint:D3DXVECTOR3)
	Return _g_3IEngine.math.PlaneLineIntersection(result,pln,firstSegmentPoint,secondSegmentPoint)
EndFunction

Function iFloatTendTo(toAdjust:Float Var,targetValue:Float,approxTimeTaken:Float)
	_g_3IEngine.math.FloatTendTo(toAdjust,targetValue,approxTimeTaken)
EndFunction

Function iFloatClamp(toClamp:Float Var,minInclusive:Float,maxInclusive:Float)
	_g_3IEngine.math.FloatClamp(toClamp,minInclusive,maxInclusive)
EndFunction

Function iIntClamp(toClamp:Int Var,minInclusive:Int,maxInclusive:Int)
	_g_3IEngine.math.IntClamp(toClamp,minInclusive,maxInclusive)
EndFunction

Function iFloatAdd(toIncrease:Float Var,increment:Float)
	_g_3IEngine.math.FloatAdd(toIncrease,increment)
EndFunction

Function iFloatAbs:Float(value:Float)
	Return _g_3IEngine.math.FloatAbs(value)
EndFunction

Function iFloatRand:Float(lowerValue:Float,upperValue:Float)
	Return _g_3IEngine.math.FloatRand(lowerValue,upperValue)
EndFunction

Function iIntRand:Int(lowerValue:Int,upperValue:Int)
	Return _g_3IEngine.math.IntRand(lowerValue,upperValue)
EndFunction

Function iSignRand:Float()
	Return _g_3IEngine.math.SignRand()
EndFunction

Function iFloatInterpolate:Float(_input:Float,sourceMin:Float,sourceMax:Float,destMin:Float,destMax:Float,bClamp:Int)
	Return _g_3IEngine.math.FloatInterpolate(_input,sourceMin,sourceMax,destMin,destMax,bClamp)
EndFunction


Extern
	' MATH
	Function _iVectorBodyToWorldTransform(D3DXVECTOR3_transformedCoords:Byte Ptr,D3DXVECTOR3_coords:Byte Ptr,BODY:Byte Ptr,mode:Int)="iVectorBodyToWorldTransform"
	Function _iVectorBodyToWorldRotate(D3DXVECTOR3_transformedCoords:Byte Ptr,D3DXVECTOR3_coords:Byte Ptr,BODY:Byte Ptr,mode:Int)="iVectorBodyToWorldRotate"
	Function _iVectorMeshToWorldTransform(D3DXVECTOR3_transformedCoords:Byte Ptr,D3DXVECTOR3_coords:Byte Ptr,MESH:Byte Ptr)="iVectorMeshToWorldTransform"
	Function _iVectorMeshToWorldRotate(D3DXVECTOR3_transformedCoords:Byte Ptr,D3DXVECTOR3_coords:Byte Ptr,MESH:Byte Ptr)="iVectorMeshToWorldRotate"
	Function _iVectorSkinMeshToWorldTransform(D3DXVECTOR3_transformedCoords:Byte Ptr,D3DXVECTOR3_coords:Byte Ptr,SKINMESH:Byte Ptr)="iVectorSkinMeshToWorldTransform"
	Function _iVectorSkinMeshToWorldRotate(D3DXVECTOR3_transformedCoords:Byte Ptr,D3DXVECTOR3_coords:Byte Ptr,SKINMESH:Byte Ptr)="iVectorSkinMeshToWorldRotate"
	Function _iVectorWorldToBodyTransform(D3DXVECTOR3_transformedCoords:Byte Ptr,D3DXVECTOR3_coords:Byte Ptr,BODY:Byte Ptr)="iVectorWorldToBodyTransform"
	Function _iVectorWorldToBodyRotate(D3DXVECTOR3_transformedCoords:Byte Ptr,D3DXVECTOR3_coords:Byte Ptr,BODY:Byte Ptr)="iVectorWorldToBodyRotate"
	Function _iVectorWorldToMeshTransform(D3DXVECTOR3_transformedCoords:Byte Ptr,D3DXVECTOR3_coords:Byte Ptr,MESH:Byte Ptr)="iVectorWorldToMeshTransform"
	Function _iVectorWorldToMeshRotate(D3DXVECTOR3_transformedCoords:Byte Ptr,D3DXVECTOR3_coords:Byte Ptr,MESH:Byte Ptr)="iVectorWorldToMeshRotate"
	Function _iVectorWorldToSkinMeshTransform(D3DXVECTOR3_transformedCoords:Byte Ptr,D3DXVECTOR3_coords:Byte Ptr,SKINMESH:Byte Ptr)="iVectorWorldToSkinMeshTransform"
	Function _iVectorWorldToSkinMeshRotate(D3DXVECTOR3_transformedCoords:Byte Ptr,D3DXVECTOR3_coords:Byte Ptr,SKINMESH:Byte Ptr)="iVectorWorldToSkinMeshRotate"
	Function _iVectorModelToBodyTransform(D3DXVECTOR3_transformedCoords:Byte Ptr,D3DXVECTOR3_coords:Byte Ptr,BODY:Byte Ptr)="iVectorModelToBodyTransform"
	Function _iVectorBodyToModelTransform(D3DXVECTOR3_transformedCoords:Byte Ptr,D3DXVECTOR3_coords:Byte Ptr,BODY:Byte Ptr)="iVectorBodyToModelTransform"
	Function _iVectorRotate(D3DXVECTOR3_transformedCoords:Byte Ptr,D3DXVECTOR3_coords:Byte Ptr,D3DXQUATERNION_rotation:Byte Ptr)="iVectorRotate"
	Function _iVectorEulerRotate(D3DXVECTOR3_transformedCoords:Byte Ptr,D3DXVECTOR3_coords:Byte Ptr,firstRotation:Float,secondRotation:Float,thirdRotation:Float,rotationOrder$z)="iVectorEulerRotate"
	Function _iVectorsAngleToQuaternion(D3DXQUATERNION_rotation:Byte Ptr,D3DXVECTOR3_vector1:Byte Ptr,D3DXVECTOR3_vector2:Byte Ptr,transformationFactor:Float)="iVectorsAngleToQuaternion"
	Function _iVectorsAngle:Float(D3DXVECTOR3_vector1:Byte Ptr,D3DXVECTOR3_vector2:Byte Ptr)="iVectorsAngle"
	Function _iVectorLength:Float(D3DXVECTOR3:Byte Ptr)="iVectorLength"
	Function _iVectorLengthSq:Float(D3DXVECTOR3:Byte Ptr)="iVectorLengthSq"
	Function _iVectorLengthSet(D3DXVECTOR3_transformed:Byte Ptr,D3DXVECTOR3_source:Byte Ptr,length:Float)="iVectorLengthSet"
	Function _iVectorDot:Float(D3DXVECTOR3_vector1:Byte Ptr,D3DXVECTOR3_vector2:Byte Ptr)="iVectorDot"
	Function _iVectorCross(D3DXVECTOR3_result:Byte Ptr,D3DXVECTOR3_source1:Byte Ptr,D3DXVECTOR3_source2:Byte Ptr)="iVectorCross"
	Function _iQuaternionFromAxisAngle(D3DXQUATERNION_result:Byte Ptr,D3DXVECTOR3_orientation:Byte Ptr,orientationAngle:Float)="iQuaternionFromAxisAngle"
	Function _iQuaternionToAxisAngle(D3DXQUATERNION_source:Byte Ptr,D3DXVECTOR3_orientation:Byte Ptr,orientationAngle:Float Ptr)="iQuaternionToAxisAngle"
	Function _iQuaternionFromEulerAngles(D3DXQUATERNION_result:Byte Ptr,firstRotation:Float,secondRotation:Float,thirdRotation:Float,rotationOrder$z)="iQuaternionFromEulerAngles"
	Function _iQuaternionToEulerAngles(D3DXQUATERNION_source:Byte Ptr,orientationAngleX:Float Ptr,orientationAngleY:Float Ptr,orientationAngleZ:Float Ptr)="iQuaternionToEulerAngles"
	Function _iQuaternionInterpolate(D3DXQUATERNION_result:Byte Ptr,D3DXQUATERNION_source1:Byte Ptr,D3DXQUATERNION_source2:Byte Ptr,orientationFactor:Float)="iQuaternionInterpolate"
	Function _iQuaternionLookAt(D3DXQUATERNION_result:Byte Ptr,D3DXVECTOR3_direction:Byte Ptr,D3DXVECTOR3_upDirection:Byte Ptr)="iQuaternionLookAt"
	Function _iQuaternionMultiply(D3DXQUATERNION_result:Byte Ptr,D3DXQUATERNION_source1:Byte Ptr,D3DXQUATERNION_source2:Byte Ptr)="iQuaternionMultiply"
	Function _iPlaneFromPointNormal(D3DXPLANE_result:Byte Ptr,D3DXVECTOR3_reference3DPoint:Byte Ptr,D3DXVECTOR3_referenceDirection:Byte Ptr)="iPlaneFromPointNormal"
	Function _iPlaneFromPoints(D3DXPLANE_result:Byte Ptr,D3DXVECTOR3_first3DPoint:Byte Ptr,D3DXVECTOR3_second3DPoint:Byte Ptr,D3DXVECTOR3_third3DPoint:Byte Ptr)="iPlaneFromPoints"
	Function _iPlaneLineIntersection:Int(D3DXVECTOR3_result:Byte Ptr,D3DXPLANE:Byte Ptr,D3DXVECTOR3_firstSegmentPoint:Byte Ptr,D3DXVECTOR3_secondSegmentPoint:Byte Ptr)="iPlaneLineIntersection" ' returns true/false
	Function _iFloatTendTo(toAdjust:Float Ptr,targetValue:Float,approxTimeTaken:Float)="iFloatTendTo"
	Function _iFloatClamp(toClamp:Float Ptr,minInclusive:Float,maxInclusive:Float)="iFloatClamp"
	Function _iIntClamp(toClamp:Int Ptr,minInclusive:Int,maxInclusive:Int)="iIntClamp"
	Function _iFloatAdd(toIncrease:Float Ptr,increment:Float)="iFloatAdd"
	Function _iFloatAbs:Float(value:Float)="iFloatAbs"
	Function _iFloatRand:Float(lowerValue:Float,upperValue:Float)="iFloatRand"
	Function _iIntRand:Int(lowerValue:Int,upperValue:Int)="iIntRand"
	Function _iSignRand:Float()="iSignRand"
	Function _iFloatInterpolate:Float(_input:Float,sourceMin:Float,sourceMax:Float,destMin:Float,destMax:Float,bClamp:Int)="iFloatInterpolate"

	' new in v4.1.0
	Function _iQuaternionSpline(D3DXQUATERNION_result:Byte Ptr,D3DXQUATERNION_source_preceeding:Byte Ptr,D3DXQUATERNION_source_orientation_q1:Byte Ptr,D3DXQUATERNION_source_orientation_q2:Byte Ptr,D3DXQUATERNION_source_following_orientation:Byte Ptr,intermmediate_orientation:Float)="iQuaternionSpline"
EndExtern
