' Text strings demo

' THIS SOURCE CODE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND. USE AT YOUR OWN RISK.

Strict
Framework _3Impact.Lib

Global Camera:CAMERA
Global FontWhite:FONT

' Define a 20-characters-Long String
Global TextString:String
' Define a Float variable To be used as time-counter
Global Seconds:Float

If Not i3ImpactOpen() RuntimeError "Unable to initialize the 3Impact game engine"
If Not i3ImpactSettings(_ISETTINGS(640,480,32,False,True,False)) RuntimeError "Settings failed"

Local engine:sample_3IEngine=New sample_3IEngine

engine.Start()

Type sample_3IEngine Extends _3IEngine

	Method _Init()
	   Camera=iCameraCreate(0.0,0.0,1.0,1.0)
	
	   ' Before we can Print any text we must create a font
	   FontWhite=iFontCreate("default_res\\fontwhite\\font.wid",Null)
	
	   ' Initialize the String
	   TextString="HELLO"
	
	   ' Initialize the time counter
	   Seconds = 0.0
	EndMethod
	
	Method _Run()
	   ' Update String contents
	'    sprintf(TextString,"TIME: %f",Seconds)
	
	   ' Print the String on the screen
	   iPrintCentered(TextString,_D3DXVECTOR2(0.0,0.0),_D3DXVECTOR2(1.0,1.0),0.1,FontWhite,0.0)
	
	   ' Update the time counter
	   Seconds :+ iFrq()
	EndMethod
EndType