
Function iFileOpenDialog:Int(title:String,fileTypes:String,initialPath:String Var,bAllowMultiSelect:Int)
	Local buf:TBank=CreateBank(1024)
	Local retval:Int=_iFileOpenDialog(title,fileTypes,BankBuf(buf),bAllowMultiSelect)
	initialPath=String.FromCString(BankBuf(buf))
	buf=Null
	Return retval
EndFunction

Function iFileOpenDialogNameExtract:Int(extractedFileName:String Var,filePath:String,fileIDX:Int=0)
	Local buf:TBank=CreateBank(1024)
	Local retval:Int=_iFileOpenDialogNameExtract(BankBuf(buf),filePath,fileIDX)
	extractedFileName=String.FromCString(BankBuf(buf))
	buf=Null
	Return retval
EndFunction

Function iFileSaveDialog:Int(title:String,fileTypes:String,initialPath:String Var,bWarnIfExists:Int)
	Local buf:TBank=CreateBank(1024)
	Local retval:Int=_iFileSaveDialog(title,fileTypes,BankBuf(buf),bWarnIfExists)
	initialPath=String.FromCString(BankBuf(buf))
	buf=Null
	Return retval
EndFunction

Function iFolderSelectDialog:Int(title:String,initialPath:String Var)
	Local buf:TBank=CreateBank(1024)
	Local retval:Int=_iFolderSelectDialog(title,BankBuf(buf))
	initialPath=String.FromCString(BankBuf(buf))
	buf=Null
	Return retval
EndFunction

Function iMessageBox(message:String)
	_iMessageBox(message)
EndFunction

Function iMessageBoxYesNo:Int(message:String,mode:Int)
	Return _iMessageBoxYesNo(message,mode)
EndFunction

Extern
	' GDI-DIALOGS
	Function iGDISurfaceShow()
	Function iGDISurfaceHide()
	Function _iFileOpenDialog:Int(title$z,fileTypes$z,initialPath:Byte Ptr,bAllowMultiSelect:Int)="iFileOpenDialog" ' returns true/false
	Function _iFileOpenDialogNameExtract:Int(extractedFileName:Byte Ptr,filePath$z,fileIDX:Int=0)="iFileOpenDialogNameExtract" ' returns true/false
	Function _iFileSaveDialog:Int(title$z,fileTypes$z,initialPath:Byte Ptr,bWarnIfExists:Int)="iFileSaveDialog" ' returns true/false
	Function _iFolderSelectDialog:Int(title$z,initialPath:Byte Ptr)="iFolderSelectDialog" ' returns true/false
	Function _iMessageBox(message$z)="iMessageBox"
	Function _iMessageBoxYesNo:Int(message$z,mode:Int)="iMessageBoxYesNo" ' returns true/false
EndExtern
